(function() {
  var mnml, preprocess;
  if (typeof module === "undefined") {
    mnml = this.mnml;
  } else {
    mnml = module.exports;
    mnml.parser = require("./parser").parser;
  }
  mnml.parse = function(string) {
    var preprocessed;
    if (!(string != null)) {
      throw new Error("parse() requires a string to parse");
    }
    preprocessed = preprocess(string);
    return mnml.parser.parse(preprocessed);
  };
  preprocess = function(string) {
    var content, context, heredoc, indent, line, lines, output, _, _i, _len, _ref;
    lines = string.split("\n");
    context = [0];
    output = "";
    heredoc = false;
    for (_i = 0, _len = lines.length; _i < _len; _i++) {
      line = lines[_i];
      _ref = line.match(/^(\s*)(.*)$/), _ = _ref[0], indent = _ref[1], content = _ref[2];
      indent = indent.length;
      if (content.length === 0) {
        indent = context[context.length - 1];
      }
      if (heredoc) {
        if (context[context.length - 1] === -1) {
          context[context.length - 1] = indent;
        }
        if (indent >= context[context.length - 1]) {
          indent -= context[context.length - 1];
          output += "" + (Array(indent + 1).join(" ")) + content + "\n";
          continue;
        } else {
          output += "\002\n";
          context.pop();
          heredoc = false;
        }
      }
      if (content[0] === "#") {
        continue;
      }
      if (content.length === 0) {
        continue;
      }
      if (indent > context[context.length - 1]) {
        output += "\001\n";
        context.push(indent);
      } else {
        while (indent < context[context.length - 1]) {
          output += "\002\n";
          context.pop();
        }
      }
      output += content;
      if (!heredoc && content.match(/->\s*$/)) {
        output += "\001";
        context.push(-1);
        heredoc = true;
      }
      output += "\n";
    }
    while (context.length > 1) {
      output += "\002\n";
      context.pop();
    }
    return output;
  };
}).call(this);
